# Maintainer: anon at sansorgan.es
_name=dune-typetree
pkgname="${_name}"-git
_gitcommit=d87717bda20b4d440edc408aa33f26136c398489
pkgver=2.9.r669.62e0978
pkgrel=1
#epoch=
pkgdesc="TypeTree Library for trees of statically typed objects (git version)"
arch=(x86_64)
url="https://dune-project.org/modules/${_name}"
license=('LGPL3' 'custom:GPL2 with runtime exception')
# groups=('dune-staging-git')
depends=(dune-common-git)
makedepends=(doxygen graphviz git)
#checkdepends=()
optdepends=('doxygen: Generate the class documentation from C++ sources'
  'graphviz: Graph visualization software')
provides=("${_name}=${pkgver%%.r*}")
conflicts=(${_name})
#replaces=()
#backup=()
#options=()
#install=
#changelog=
source=("git+https://github.com/dune-project/${_name}#commit=${_gitcommit}") # ${pkgname}.opts
#noextract=()
sha512sums=('SKIP')

pkgver() {
  cd "${_name}"
  printf "2.9.r%s.%s" "$(git rev-list --count HEAD)" "$(git rev-parse --short HEAD)"
}

prepare() {
  sed -i 's/^Version: '"${pkgver%%.r*}"'-git/Version: '"${pkgver%%.r*}"'/' ${_name}/dune.module
}

build() {
  cmake \
    -S "${_name}" \
    -B build-cmake \
    -DCMAKE_BUILD_TYPE=None \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DBUILD_SHARED_LIBS=TRUE \
    -DCMAKE_CXX_STANDARD=17 \
    -DCMAKE_C_COMPILER=gcc \
    -DCMAKE_CXX_COMPILER=g++ \
    -DCMAKE_C_FLAGS='-Wall -fdiagnostics-color=always' \
    -DCMAKE_CXX_FLAGS="-Wall -fdiagnostics-color=always -mavx" \
    -DCMAKE_VERBOSE_MAKEFILE=ON \
    -DCMAKE_POSITION_INDEPENDENT_CODE=TRUE \
    -DENABLE_HEADERCHECK=ON \
    -DCMAKE_DISABLE_FIND_PACKAGE_Vc=TRUE \
    -Wno-dev
  cmake --build build-cmake --target all # help
}
# dunecontrol --opts=${pkgname}.opts cmake -Wno-dev : make

check() {
  cmake --build build-cmake --target build_tests
  ctest --verbose --output-on-failure --test-dir build-cmake
}
# dunecontrol --opts=${pkgname}.opts make build_tests
# cd "${_name}/build-cmake"
# dune-ctest --verbose --output-on-failure

package() {
  # dunecontrol --only=${_name} make install DESTDIR="${pkgdir}"
  DESTDIR="${pkgdir}" cmake --build build-cmake --target install
  install -Dm644 ${_name}/COPYING "${pkgdir}/usr/share/licenses/${_name}/LICENSE"
  find "${pkgdir}" -type d -empty -delete
}
